﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace AllControlsSamples.ViewModel
{
    public class ReceiveValueCommand : ICommand, INotifyPropertyChanged
    {
        public string ReceivedValue
        {
            get;
            private set;
        }

        public bool CanExecute(object parameter)
        {
            // Entering the words "Hello World" will disable the command!
            return parameter != null
                && parameter.ToString() != "Hello World";
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            // Command was invoked
            if (parameter == null)
            {
                ReceivedValue = "Null";
            }
            else
            {
                ReceivedValue = parameter.ToString();
            }

            // Notify the bindings
            if (PropertyChanged != null)
            {
                PropertyChanged(this, 
                    new PropertyChangedEventArgs("ReceivedValue"));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
