﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;

namespace AllControlsSamples.Views
{
    public partial class ChildWindowSample : Page
    {
        public ChildWindowSample()
        {
            InitializeComponent();
        }

        private void OpenWindowButton_Click(object sender, RoutedEventArgs e)
        {
            var window = new MyChildWindow();

            window.Closed += window_Closed;

            var storyboard = Resources["RectangleStoryboard"] as Storyboard;
            if (storyboard != null)
            {
                storyboard.Begin();
            }

            window.Show();
        }

        void window_Closed(object sender, EventArgs e)
        {
            var window = sender as MyChildWindow;
            if (window != null
                && window.DialogResult == true)
            {
                InputTextBlock.Text = window.Input;
            }

            var storyboard = Resources["RectangleStoryboard"] as Storyboard;
            if (storyboard != null)
            {
                storyboard.Stop();
            }
        }
    }
}
