﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace AllControlsSamples.Views
{
    public partial class MyChildWindow : ChildWindow
    {
        public const string InputPropertyName = "Input";

        public string Input
        {
            get
            {
                return (string)GetValue(InputProperty);
            }
            set
            {
                SetValue(InputProperty, value);
            }
        }

        public static readonly DependencyProperty InputProperty 
            = DependencyProperty.Register(
            InputPropertyName,
            typeof(string),
            typeof(MyChildWindow),
            new PropertyMetadata("Enter a text..."));

        public MyChildWindow()
        {
            InitializeComponent();
        }

        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }
    }
}

