﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace AttachedProperties
{
    public partial class PresentationWindow : ChildWindow
    {
        public const string CaptionPropertyName = "Caption";

        public static string GetCaption(DependencyObject obj)
        {
            return (string)obj.GetValue(CaptionProperty);
        }

        public static void SetCaption(DependencyObject obj, string value)
        {
            obj.SetValue(CaptionProperty, value);
        }

        public static readonly DependencyProperty CaptionProperty
            = DependencyProperty.RegisterAttached(
            CaptionPropertyName,
            typeof(string),
            typeof(PresentationWindow),
            new PropertyMetadata(string.Empty));

        public void Present(UIElement element)
        {
            PresentationGrid.Children.Add(element);

            // Use attached properties (if available)

            var caption = GetCaption(element);
            if (caption != null)
            {
                this.Title = caption;
            }

            this.Show();
        }

        public PresentationWindow()
        {
            InitializeComponent();
        }

        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
            PresentationGrid.Children.Clear();
            Title = string.Empty;
        }
    }
}

