﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using AuthenticationSample.AuthenticationService;

namespace AuthenticationSample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void LoginClick(object sender, RoutedEventArgs e)
        {
            MessageTextBlock.Text = "Logging in";
            var client 
                = new AuthenticationService.AuthenticationServiceClient();
            client.LoginCompleted += client_LoginCompleted;
            UserNameTextBox.IsEnabled = false;
            PasswordTextBox.IsEnabled = false;
            client.LoginAsync(
                UserNameTextBox.Text, 
                PasswordTextBox.Password, 
                string.Empty, 
                true, 
                UserNameTextBox);
        }

        void client_LoginCompleted(
            object sender,
            LoginCompletedEventArgs e)
        {
            if (e.Result)
            {
                MessageTextBlock.Text = "Logged in, Checking access";

                var client
                    = new CheckAccessService.CheckAccessServiceClient();
                client.CanAccessManagerZoneCompleted 
                    += client_CanAccessManagerZoneCompleted;
                client.CanAccessManagerZoneAsync();
            }
            else
            {
                MessageTextBlock.Text = "Access denied";
            }
        }

        void client_CanAccessManagerZoneCompleted(
            object sender,
            CheckAccessService.CanAccessManagerZoneCompletedEventArgs e)
        {
            LoginPanel.Visibility = Visibility.Collapsed;

            if (e.Result)
            {
                ShowManagerPage();
            }
            else
            {
                ShowEmployeePage();
            }
        }

        private void ShowEmployeePage()
        {
            MessageBox.Show("Employee");
        }

        private void ShowManagerPage()
        {
            MessageBox.Show("Manager");
        }

        private void CancelClick(object sender, RoutedEventArgs e)
        {
            System.Windows.Browser.HtmlPage.Window.Navigate(new Uri("http://www.silverlight.net"));
        }
    }
}
