﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using Expression.Blend.SampleData.SampleDataSource;

namespace BindsDirectlyToSourceSample
{
    public partial class MainPage : UserControl
    {
        public const string MyPagedViewPropertyName = "MyPagedView";

        public ICollectionView MyPagedView
        {
            get
            {
                return (ICollectionView)GetValue(MyPagedViewProperty);
            }
            set
            {
                SetValue(MyPagedViewProperty, value);
            }
        }

        public static readonly DependencyProperty MyPagedViewProperty = DependencyProperty.Register(
            MyPagedViewPropertyName,
            typeof(ICollectionView),
            typeof(MainPage),
            new PropertyMetadata(null));



        public MainPage()
        {
            InitializeComponent();

            var mySource = App.Current.Resources["SampleDataSource"] as SampleDataSource;
            var pagedView = new PagedCollectionView(mySource.Collection);

            pagedView.SortDescriptions.Add(new SortDescription
            {
                Direction = ListSortDirection.Descending,
                PropertyName = "Property1"
            });

            pagedView.SortDescriptions.Add(new SortDescription
            {
                Direction = ListSortDirection.Ascending,
                PropertyName = "Property2"
            });

            MyPagedView = pagedView;
        }
    }

    public class MyProvider
    {
        
    }
}
