﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Maps.MapControl;

namespace BingMapsSample
{
    public partial class MainPage : UserControl
    {
        private readonly MapLayer _mapLayer;

        public MainPage()
        {
            InitializeComponent();
            _mapLayer = new MapLayer();
            MyMap.Children.Add(_mapLayer);
            MyMap.MouseClick += MapClick;
        }

        private void MapClick(
            object sender, 
            Microsoft.Maps.MapControl.MapMouseEventArgs e)
        {
            var location = MyMap.ViewportPointToLocation(
                e.ViewportPoint);

            var marker = new Ellipse
            {
                Fill = new SolidColorBrush(Colors.Red),
                Height = 10,
                Width = 10,
            };

            var tooltipPanel = new StackPanel();

            tooltipPanel.Children.Add(new TextBlock
            {
                Text = "Lat: " + location.Latitude
            });

            tooltipPanel.Children.Add(new TextBlock
            {
                Text = "Lon: " + location.Longitude
            });

            ToolTipService.SetToolTip(
                marker, tooltipPanel);

            var position = PositionOrigin.Center;
            _mapLayer.AddChild(marker, location, position);
        }
    }
}
