﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.ComponentModel;

namespace CollectionViewSourceSample
{
	public partial class MainPage : UserControl
	{
        public const string MyViewPropertyName = "MyView";

        public ICollectionView MyView
        {
            get
            {
                return (ICollectionView)GetValue(MyViewProperty);
            }
            set
            {
                SetValue(MyViewProperty, value);
            }
        }

        public static readonly DependencyProperty MyViewProperty = DependencyProperty.Register(
            MyViewPropertyName,
            typeof(ICollectionView),
            typeof(MainPage),
            new PropertyMetadata(null));

		public MainPage()
		{
			// Required to initialize variables
			InitializeComponent();

            var cvs = Resources["MyCvs"] as CollectionViewSource;
            MyView = cvs.View;

            //MyDetailsBorder.DataContext = cvs.View.CurrentItem;
		}

        private void ToggleButton_Click(object sender, RoutedEventArgs e)
        {
            var button = sender as ToggleButton;
            var sortUp = button.IsChecked.Value;

            var cvs = this.Resources["MyCvs"] 
                as CollectionViewSource;
            cvs.SortDescriptions.Clear();

            var sort = new SortDescription
            {
                PropertyName = "MyString",
                Direction = (sortUp
                    ? ListSortDirection.Ascending
                    : ListSortDirection.Descending)
            };

            cvs.SortDescriptions.Add(sort);
        }
	}
}