﻿using System;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using System.ServiceModel.Web;

namespace Customers
{
    [ServiceContract(Namespace = "http://www.galasoft.ch")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class CustomerService
    {
        [OperationContract]
        public IEnumerable<Customer> GetCustomers(string lastName)
        {
            var factory = new CustomerAccess();
            var customersFound = factory.Get(lastName);

            System.Threading.Thread.Sleep(5000);

            return customersFound;
        }

        [OperationContract]
        public Customer GetCustomerByAccountNumber(int accountNumber)
        {
            var factory = new CustomerAccess();
            var customerFound = factory.Get(accountNumber);
            return customerFound;
        }

        [OperationContract]
        public IEnumerable<Customer> GetAllCustomers()
        {
            var factory = new CustomerAccess();
            var customersFound = factory.Get();
            return customersFound;
        }

        [OperationContract]
        public bool SaveCustomers(IEnumerable<Customer> editedCustomers)
        {
            var factory = new CustomerAccess();
            return factory.Save(editedCustomers);
        }

        [OperationContract]
        [WebGet(ResponseFormat = WebMessageFormat.Json,
          UriTemplate = "Save/{accountNumber}/{newName}")]
        public bool SaveCustomerLastName(string accountNumber, string newName)
        {
            Customer customer = null;

            try
            {
                var account = Int32.Parse(accountNumber);
                customer = GetCustomerByAccountNumber(account);
            }
            catch (FormatException)
            { }

            if (customer != null)
            {
                customer.LastName = newName;
                return SaveCustomers(new[] { customer });
            }
            return false;
        }
    }
}
