﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using CustomersManager.SL.ViewModel;

namespace CustomersManager.SL
{
    public partial class MainPage : UserControl, IDialogService
    {
        public MainPage()
        {
            InitializeComponent();

            var vm = DataContext as MainViewModel;
            if (vm != null)
            {
                vm.DialogService = this;
            }
        }

        public void ShowMessage(string message, string caption)
        {
            MessageBox.Show(message, caption, MessageBoxButton.OK);
        }

        public FileInfo OpenFile(string filter)
        {
            var dialog = new OpenFileDialog
            {
                Filter = filter,
                Multiselect = false
            };

            if (dialog.ShowDialog() == true)
            {
                return dialog.File;
            }

            return null;
        }
    }
}
