﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using CustomersManager.SL.Model;
using CustomersManager.SL.RemoteCustomersService;
using CustomersManager.SL.ViewModel;

namespace CustomersManager.SL.Design
{
    public class DesignCustomersService : ICustomersService
    {
        private readonly Random _random = new Random();

        public void GetCustomers(Action<IEnumerable<CustomerViewModel>, Exception> callback)
        {
            var customers = new List<CustomerViewModel>();
            for (var index = 0; index < 100; index++)
            {

                customers.Add(CreateCustomer(index));
            }

            callback(customers.AsEnumerable(), null);
        }

        public CustomerViewModel CreateCustomer(int index)
        {
            var model = new Customer
            {
                FirstName = "FirstName" + index,
                LastName = "LastName" + index,
                PictureUri = GetKnownPictureUri(0),
                AccountNumber = _random.Next(1000, 9999),
                Gender = (_random.Next(0, 1) == 0) ? CustomerGender.Male : CustomerGender.Female
            };

            return new CustomerViewModel(model);
        }

        public Uri GetKnownPictureUri(int accountNumber)
        {
            return new Uri("http://www.galasoft.ch/logo/Current/bighead.png");
        }

        public void SaveCustomer(CustomerViewModel customer, Action<bool> callback)
        {
            callback(true);
        }

        public void SavePicture(Stream pictureStream, int accountNumber, Action<bool, string> callback)
        {
            callback(true, string.Empty);
        }
    }
}
