﻿using CustomersManager.SL.RemoteCustomersService;
using GalaSoft.MvvmLight;

namespace CustomersManager.SL.ViewModel
{
    public partial class CustomerViewModel : ViewModelBase
    {
        public const string IsDirtyPropertyName = "IsDirty";
        private bool _isDirty;
        public bool IsDirty
        {
            get
            {
                return _isDirty;
            }

            set
            {
                if (_isDirty == value)
                {
                    return;
                }

                _isDirty = value;
                RaisePropertyChanged(IsDirtyPropertyName);
            }
        }

        public const string IsNewPropertyName = "IsNew";
        private bool _isNew;
        public bool IsNew
        {
            get
            {
                return _isNew;
            }

            set
            {
                if (_isNew == value)
                {
                    return;
                }

                _isNew = value;
                RaisePropertyChanged(IsNewPropertyName);
            }
        }

        public Customer Model
        {
            get;
            private set;
        }

        public CustomerViewModel(Customer model)
        {
            Model = model;
            Model.PropertyChanged += (s, e) =>
            {
                IsDirty = true;
            };
        }
    }
}
