﻿using System.ComponentModel;
using CustomersManager.SL.Model;

namespace CustomersManager.SL.ViewModel
{
    public class ViewModelLocator
    {
        private static MainViewModel _main;

        static ViewModelLocator()
        {
            ICustomersService customerService;

            if (DesignerProperties.IsInDesignTool)
            {
                customerService = new Design.DesignCustomersService();
            }
            else
            {
                customerService = new CustomersService();
            }

            _main = new MainViewModel(customerService);
        }

        public MainViewModel Main
        {
            get
            {
                return _main;
            }
        }

        /// <summary>
        /// Cleans up all the resources.
        /// </summary>
        public static void Cleanup()
        {
            _main.Cleanup();
            _main = null;
        }
    }
}