﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using CustomersManager.SL.ViewModel;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace CustomersManager.WP7
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        public enum IconButtons
        {
            Edit = 0,
            Cancel = 1
         }

        public void EnableButton(IconButtons whichButton, bool enable)
        {
            (ApplicationBar.Buttons[(int)whichButton] 
                as ApplicationBarIconButton).IsEnabled = enable;
        }

        private void EditButtonClick(object sender, EventArgs e)
        {
            EnableButton(IconButtons.Edit, false);
            EnableButton(IconButtons.Cancel, true);
            VisualStateManager.GoToState(this, "Edit", true);
        }

        private void CancelButtonClick(object sender, EventArgs e)
        {
            EnableButton(IconButtons.Edit, true);
            EnableButton(IconButtons.Cancel, false);
            VisualStateManager.GoToState(this, "Normal", true);
        }

        private void RefreshClick(object sender, EventArgs e)
        {
            var vm = DataContext as MainViewModel;
            if (vm != null)
            {
                vm.RefreshCommand.Execute(null);
            }
        }
    }
}
