﻿using System.Windows.Controls;
using DataApplicationSample.Model;
using DataApplicationSample.ViewModel;
using System.Windows.Data;

namespace DataApplicationSample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            var service = new CustomerServiceProxy();
            var vm = new MainViewModel(service);
            DataContext = vm;

            var pcv = new PagedCollectionView(vm.Customers);
            pcv.PageSize = 2;
            CustomersDataGrid.ItemsSource = pcv;
        }

        private void checkBox1_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            var checkbox = sender as CheckBox;
            var pcv = CustomersDataGrid.ItemsSource as PagedCollectionView;
            if (checkbox != null
                && pcv != null)
            {
                if (checkbox.IsChecked == true)
                {
                    pcv.Filter = c =>
                    {
                        var customer = c as CustomerViewModel;

                        return customer != null
                               && customer.Model != null
                               && customer.Model.PictureUri != null;
                    };
                }
                else
                {
                    pcv.Filter = null;
                }
            }
        }
    }
}
