﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Net.Browser;
using System.Threading;

namespace DownloadUpload.Helpers
{
    public class CookieSample
    {
        private const string ServerPath = "http://localhost:8975/";
        private const string CookieService = "CookieService.ashx";

        public static void SendCookie()
        {
            WebRequest.RegisterPrefix("http://", WebRequestCreator.ClientHttp);

            var request = (HttpWebRequest)
                WebRequest.Create(ServerPath + CookieService);

            request.CookieContainer = new CookieContainer();

            request.CookieContainer.Add(new Uri(ServerPath),
                new Cookie("mycookie", "Hello"));
            request.BeginGetResponse(ReadCallback, request);
        }

        private static void ReadCallback(IAsyncResult result)
        {
            var request = (HttpWebRequest)result.AsyncState;
            var response = request.EndGetResponse(result)
                as HttpWebResponse;
            var stringValue = response.Cookies["mycookie"].Value;
        }
    }
}
