﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using GreetingCardMaker.ViewModel;
using System.Windows.Media.Imaging;
using System.IO;

namespace GreetingCardMaker
{
    public partial class MainPage : UserControl, IDialogService
    {
        public MainPage()
        {
            InitializeComponent();

            var vm = DataContext as MainViewModel;
            if (vm != null)
            {
                vm.DialogService = this;
            }
        }

        public void ShowMessage(string content)
        {
            MessageBox.Show(content);
        }

        public bool AskConfirmation(string message)
        {
            var result = MessageBox.Show(
                message,
                "Are you sure?",
                MessageBoxButton.OKCancel);

            return result == MessageBoxResult.OK;
        }

    }
}
