﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using ImplicitBindingCommandParameter.Data;

namespace ImplicitBindingCommandParameter.ViewModel
{
    public class MainViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public ICommand DisplayItem
        {
            get;
            private set;
        }

        public ObservableCollection<DataItem> Items
        {
            get;
            private set;
        }

        public MainViewModel()
        {
            DisplayItem = new DisplayItemCommand();

            Items = new ObservableCollection<DataItem>();

            for (var index = 0; index < 10; index++)
            {
                var item = new DataItem
                {
                    Name = "Item#" + index
                };

                Items.Add(item);
            }
        }

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
