﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace InheritingDO.Data
{
    public class Customer : DependencyObject
    {
        // Name Dependency Property

        public const string NamePropertyName = "Name";

        public string Name
        {
            get
            {
                return (string)GetValue(NameProperty);
            }
            set
            {
                SetValue(NameProperty, value);
            }
        }

        public static readonly DependencyProperty NameProperty 
            = DependencyProperty.Register(
            NamePropertyName,
            typeof(string),
            typeof(Customer),
            new PropertyMetadata(string.Empty, UpdateNumberOfChanges));

        private static void UpdateNumberOfChanges(
            DependencyObject d,
            DependencyPropertyChangedEventArgs e)
        {
            var sender = d as Customer;
            sender.NumberOfChanges++;
        }

        // ContractNumber Dependency Property

        public const string ContractNumberPropertyName = "ContractNumber";

        public int ContractNumber
        {
            get
            {
                return (int)GetValue(ContractNumberProperty);
            }
            set
            {
                SetValue(ContractNumberProperty, value);
            }
        }

        public static readonly DependencyProperty ContractNumberProperty = DependencyProperty.Register(
            ContractNumberPropertyName,
            typeof(int),
            typeof(Customer),
            new PropertyMetadata(0));

        public const string NumberOfChangesPropertyName = "NumberOfChanges";

        public int NumberOfChanges
        {
            get
            {
                return (int)GetValue(NumberOfChangesProperty);
            }
            set
            {
                SetValue(NumberOfChangesProperty, value);
            }
        }

        public static readonly DependencyProperty NumberOfChangesProperty = DependencyProperty.Register(
            NumberOfChangesPropertyName,
            typeof(int),
            typeof(Customer),
            new PropertyMetadata(0));

        public Customer(string name, int contractNumber)
        {
            Name = name;
            ContractNumber = contractNumber;
        }
    }
}
