﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Linq;

namespace InheritingDO.Data
{
    public class CustomerService
    {
        // This is a dummy service that returns a list of customers.
        // In a real life application, this service would access a web service,
        // a database, etc...

        public IEnumerable<Customer> GetCustomers()
        {
            var list = new List<Customer>();

            for (var index = 0; index < 5; index++)
            {
                list.Add(MakeCustomer(index));
            }

            return list.AsEnumerable<Customer>();
        }

        private readonly Random _random = new Random();

        private readonly string[] _names =
        {
            "Aaberg, Jesper",
            "Adams, Ellen",
            "Adams, Terry",
            "Bugnion, Laurent",
            "Penor, Lori",
            "Pfeiffer, Michael",
            "Philips, Carol",
            "Poe, Toni",
            "Hicks, Cassie",
            "Argentiero, Luca"
        };

        private Customer MakeCustomer(int index)
        {
            var customer = new Customer(_names[index], _random.Next(1000, 2000));
            return customer;
        }
    }
}
