﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace InheritingDO.Data
{
    /// <summary>
    /// This class is used to demonstrate the correct way to
    /// initialize the object with two dependency properties.
    /// </summary>
    public class DataObject : DependencyObject
    {
        private string _lowerCaseStrings = string.Empty;

        public const string Test1PropertyName = "Test1";

        public string Test1
        {
            get { return (string)GetValue(Test1Property); }
            set { SetValue(Test1Property, value); }
        }

        public static readonly DependencyProperty Test1Property 
            = DependencyProperty.Register(
            Test1PropertyName,
            typeof(string),
            typeof(DataObject),
            new PropertyMetadata(null, UpdateLowerCase));

        public const string Test2PropertyName = "Test2";

        public string Test2
        {
            get { return (string)GetValue(Test2Property); }
            set { SetValue(Test2Property, value); }
        }

        public static readonly DependencyProperty Test2Property
            = DependencyProperty.Register(
            Test2PropertyName,
            typeof(string),
            typeof(DataObject),
            new PropertyMetadata(null, UpdateLowerCase));

        private static void UpdateLowerCase(
            DependencyObject d,
            DependencyPropertyChangedEventArgs e)
        {
            var sender = d as DataObject;

            if (sender.Test1 == null
                || sender.Test2 == null)
            {
                return;
            }

            sender._lowerCaseStrings 
                = sender.Test1.ToLower()
                + sender.Test2.ToLower();
        }
    }
}
