﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace LockingResources
{
    public partial class MainPage : UserControl
    {
        public ObservableCollection<string> Items
        {
            get;
            private set;
        }

        public MainPage()
        {
            Items = new ObservableCollection<string>();
            InitializeComponent();
            StartThreadedOperation();
        }

        private void StartThreadedOperation()
        {
            for (var index = 0; index < 3; index++)
            {
                CreateAndStartWorker(index);
            }
        }

        private void CreateAndStartWorker(int workerIndex)
        {
            var worker = new BackgroundWorker
            {
                WorkerReportsProgress = true
            };

            //worker.DoWork += (s, e) =>
            //{
            //    Thread.CurrentThread.Name
            //        = "Worker # " + workerIndex;
            //    for (var index = 0; index < 10; index++)
            //    {
            //        Thread.Sleep(100);
            //        worker.ReportProgress(
            //            index * 10,
            //            string.Format(
            //               "Worker # {0}, Operation # {1}", 
            //               workerIndex, index));
            //    }
            //};

            worker.DoWork += (s, e) =>
            {
                Thread.CurrentThread.Name = "Worker # " + workerIndex;
                lock (Items)
                {
                    for (var index = 0; index < 10; index++)
                    {
                        Thread.Sleep(100);
                        worker.ReportProgress(
                            index * 10,
                            string.Format(
                                "Worker # {0}, Operation # {1}",
                                workerIndex,
                                index));
                    }
                }
            };

            worker.ProgressChanged += (s, e) =>
            {
                Items.Add(e.UserState.ToString());
            };

            worker.RunWorkerAsync();
        }
    }
}
