﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;

namespace MefPlugins.Web
{
    /// <summary>
    /// Summary description for PluginsService
    /// </summary>
    public class PluginsService : IHttpHandler
    {
        private const string PluginsFolderName = "Plugins/";

        public void ProcessRequest(HttpContext context)
        {
            var pluginFolder = new DirectoryInfo(
                HttpContext.Current.Server.MapPath(
                PluginsFolderName));
            var response = new StringBuilder();

            if (pluginFolder.Exists)
            {
                foreach (var xap in pluginFolder.GetFiles("*.xap"))
                {
                    response.AppendLine(
                        PluginsFolderName + xap.Name);
                }
            }
            context.Response.ContentType = "text/plain";
            context.Response.Write(response);
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}