﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Messaging;
using System.Windows.Shapes;

namespace MessagingSender
{
    public partial class MainPage : UserControl
    {
        private LocalMessageSender _sender;

        public MainPage()
        {
            _sender = new LocalMessageSender(
                "MessagingApplication2",
                LocalMessageSender.Global);
            _sender.SendCompleted += _sender_SendCompleted;

            InitializeComponent();
        }

        void _sender_SendCompleted(object sender, SendCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                MessageTextBlock.Text = e.Error.Message;
                return;
            }

            if (!string.IsNullOrEmpty(e.Response))
            {
                MessageTextBlock.Text = e.Response;
                return;
            }

            MessageTextBlock.Text = "Message sent";
        }

        private void SendClick(object sender, RoutedEventArgs e)
        {
            _sender.SendAsync(SendingMessageTextBox.Text);
        }
    }
}
