﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using MyNorthwind.Silverlight.ViewModel;

namespace MyNorthwind.Silverlight
{
    public partial class MainPage : UserControl, IDialogService, IPrintService 
    {
        public MainPage()
        {
            InitializeComponent();

            var vm = LayoutRoot.DataContext as MainViewModel;
            if (vm != null)
            {
                vm.DialogService = this;
                vm.PrintService = this;
            }
        }

        private void orderDomainDataSource_LoadedData(object sender, System.Windows.Controls.LoadedDataEventArgs e)
        {

            if (e.HasError)
            {
                System.Windows.MessageBox.Show(e.Error.ToString(), "Load Error", System.Windows.MessageBoxButton.OK);
                e.MarkErrorAsHandled();
            }
        }

        public void ShowMessage(string content)
        {
            MessageBox.Show(content);
        }

        public bool AskConfirmation(string message)
        {
            var result = MessageBox.Show(
                message,
                "Are you sure?",
                MessageBoxButton.OKCancel);

            return result == MessageBoxResult.OK;
        }

        private void CityStartTextBox_LostFocus(
            object sender, RoutedEventArgs e)
        {
            var vm = LayoutRoot.DataContext as MainViewModel;
            if (vm != null)
            {
                vm.LoadAllOrdersByCity(CityStartTextBox.Text);
            }
        }

        public void PrintOrders()
        {
            var printWindow = new PrintWindow(CityStartTextBox.Text);
            printWindow.Show();
        }
    }
}
