﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using MyNorthwind.Web;

namespace MyNorthwind.Silverlight
{
    public partial class PrintedReport : UserControl
    {
        public PrintedReport()
        {
            InitializeComponent();
        }

        public int NumberOfOrders
        { get; private set; }

        public void PreparePage(
            IEnumerable<Order> orders,
            int startIndex, Size pageSize)
        {
            OrdersPanel.Children.Clear();
            UpdateLayout();

            foreach (var order in orders.Skip(startIndex))
            {
                var content = new ContentPresenter
                {
                    Content = order,
                    ContentTemplate = Resources["OrdersTemplate"] as DataTemplate
                };

                OrdersPanel.Children.Add(content);
                UpdateLayout();

                if (DesiredSize.Height >= pageSize.Height)
                {
                    OrdersPanel.Children.Remove(content);
                    break;
                }
            }

            NumberOfOrders = OrdersPanel.Children.Count;
            FooterTextBlock.Text = string.Format(
                "Orders {0} to {1}",
                startIndex + 1,
                startIndex + NumberOfOrders);
            
            UpdateLayout();
        }
    }
}
