﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices.Automation;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using MyNorthwind.Web;

namespace MyNorthwind.Silverlight
{
    public partial class ReportingWindow : ChildWindow
    {
        private const int MailItemTypeByValue = 1; // olByValue
        private const int CreateItemTypeEmail = 0; // olMailItem
        private IEnumerable<Order> _orders;

        public ReportingWindow(IEnumerable<Order> orders)
        {
            _orders = orders;
            InitializeComponent();
        }

        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            dynamic excelApplication =
                AutomationFactory.CreateObject("Excel.Application");
             excelApplication.Visible = false;

            dynamic excelWorkbook = excelApplication.Workbooks.Add();
            dynamic excelSheet = excelApplication.ActiveSheet;
            dynamic excelCell;

            excelCell = excelSheet.Cells[1, 1];
            excelCell.Value = "Date";
            excelCell.ColumnWidth = 25;
            excelCell = excelSheet.Cells[1, 2];
            excelCell.Value = "ID";
            excelCell.ColumnWidth = 15;
            excelCell = excelSheet.Cells[1, 3];
            excelCell.Value = "Ship";
            excelCell.ColumnWidth = 25;
            excelCell = excelSheet.Cells[1, 4];
            excelCell.Value = "To";
            excelCell.ColumnWidth = 40;
            excelCell = excelSheet.Cells[1, 5];
            excelCell.Value = "Value";
            excelCell.ColumnWidth = 25;

            int index = 2;
            foreach (Order o in _orders)
            {
                excelCell = excelSheet.Cells[index, 1];
                excelCell.Value = o.OrderDate;
                excelCell = excelSheet.Cells[index, 2];
                excelCell.Value = o.OrderID;
                excelCell = excelSheet.Cells[index, 3];
                excelCell.Value = o.ShipName;
                excelCell = excelSheet.Cells[index, 4];
                excelCell.Value = o.ShipCity;
                excelCell = excelSheet.Cells[index, 5];
                excelCell.Value = o.Freight;
                index++;
            }

            var directoryPath = System.IO.Path.Combine(
                Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments),
                "Northwind.Web.Temp");

            if (Directory.Exists(directoryPath))
            {
                Directory.Delete(directoryPath, true);
            }

            Directory.CreateDirectory(directoryPath);

            var fileName = System.IO.Path.Combine(
                directoryPath,
                AttachmentNameTextBox.Text + ".xlsx");

            excelWorkbook.SaveAs(fileName);
            excelApplication.Quit();

            dynamic outlook = AutomationFactory.CreateObject("Outlook.Application");
            dynamic mail = outlook.CreateItem(CreateItemTypeEmail);
            mail.Recipients.Add(EmailTextBox.Text);
            mail.Subject = SubjectTextBox.Text;
             var now = DateTime.Now;
            mail.Body = "Report generated on " + now.ToLongDateString()
                + ", " + now.ToShortTimeString();
            mail.Attachments.Add(fileName, MailItemTypeByValue);
            mail.Save();
            mail.Display(false);
            Directory.Delete(directoryPath, true);

            DialogResult = true;
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }
    }
}

