﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Interactivity;

namespace MyOwnBehaviors
{
	public class DisplayMessageAction : TriggerAction<TextBox>
	{
        public const string MessagePropertyName = "Message";

        public string Message
        {
            get
            {
                return (string)GetValue(MessageProperty);
            }
            set
            {
                SetValue(MessageProperty, value);
            }
        }

        public static readonly DependencyProperty MessageProperty 
            = DependencyProperty.Register(
            MessagePropertyName,
            typeof(string),
            typeof(DisplayMessageAction),
            new PropertyMetadata("-empty-"));

        public DisplayMessageAction()
		{
		}

		protected override void Invoke(object o)
		{
            MessageBox.Show(
                string.Format("It is now {0}; your message is {1}",
                DateTime.Now.ToString(),
                Message));
        }
	}
}