﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Interactivity;
using System.Windows.Controls.Primitives;
//using Microsoft.Expression.Interactivity.Core;

namespace MyOwnBlendBehaviors
{
    public class ClickMessageBehavior : Behavior<ButtonBase>
    {
        protected override void OnAttached()
        {
            base.OnAttached();

            if (AssociatedObject != null)
            {
                AssociatedObject.Click += SayHello;
            }
        }

        private static void SayHello(object sender, RoutedEventArgs e)
        {
            var now = DateTime.Now;

            MessageBox.Show(string.Format(
                "Hello, it is the {0} at {1}",
                now.ToShortDateString(),
                now.ToShortTimeString()));
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();

            AssociatedObject.Click -= SayHello;
        }
    }
}