﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace RandomAnimationSample
{
	public partial class MainPage : UserControl
	{
        private readonly Storyboard _randomAnimation;
        private readonly Random _random;

        public MainPage()
        {
	        InitializeComponent();

            _random = new Random();
            _randomAnimation = Resources["RandomAnimation"] as Storyboard;
            _randomAnimation.Completed += (s, e) => StartNextAnimation();
	        StartNextAnimation();
        }

        private void StartNextAnimation()
        {
            // Calculate target size
            (_randomAnimation.Children[0] as DoubleAnimation).To
                = (_randomAnimation.Children[1] as DoubleAnimation).To
                = (double) _random.Next(4, 20) / 10;

            // Calculate target angle
            (_randomAnimation.Children[2] as DoubleAnimation).To 
                = _random.Next(0, 720);

            // Calculate duration
            _randomAnimation.Duration 
                = TimeSpan.FromMilliseconds(_random.Next(800, 2000));
            _randomAnimation.Begin();
        }
	}
}