﻿using SampleMvvm.CustomerWcfService;
using SampleMvvm.MvvmHelpers;

namespace SampleMvvm.ViewModel
{
    public class CustomerViewModel : ViewModelBase
    {
        public Customer Model
        {
            get;
            private set;
        }

        /// <summary>
        /// The <see cref="IsDirty" /> property's name.
        /// </summary>
        public const string IsDirtyPropertyName = "IsDirty";

        private bool _isDirty;

        /// <summary>
        /// Gets the IsDirty property.
        /// Changes to that property's value raise the PropertyChanged event. 
        /// </summary>
        public bool IsDirty
        {
            get
            {
                return _isDirty;
            }

            set
            {
                if (_isDirty == value)
                {
                    return;
                }

                _isDirty = value;
                RaisePropertyChanged(IsDirtyPropertyName);
            }
        }

        public CustomerViewModel(Customer model)
        {
            Model = model;
            model.PropertyChanged += (s, e) =>
            {
                IsDirty = true;
            };
        }
    }
}
