﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using SampleMvvm.CustomerWcfService;
using SampleMvvm.Model;
using SampleMvvm.MvvmHelpers;

namespace SampleMvvm.ViewModel
{
    public class MainViewModel : ViewModelBase
    {
        public ObservableCollection<CustomerViewModel> Customers
        {
            get;
            private set;
        }

        public MainViewModel(ICustomerServiceProxy service)
        {
            Customers = new ObservableCollection<CustomerViewModel>();
            service.GetCustomers(HandleResult);
        }

        private void HandleResult(IEnumerable<Customer> result, Exception ex)
        {
            Customers.Clear();

            if (ex != null)
            {
                ShowError(ex);
                return;
            }

            if (result == null)
            {
                return;
            }

            foreach (var customer in result)
            {
                var vm = new CustomerViewModel(customer);
                Customers.Add(vm);
            }
        }

        private void ShowError(Exception ex)
        {
            // TODO
        }
    }
}