﻿using System;
using System.Windows;
using System.Windows.Media.Effects;

namespace ShaderTest.MyShaders
{
    public class WaveEffect : ShaderEffect
    {
        public static readonly DependencyProperty AmplitudeProperty
            = DependencyProperty.Register("Amplitude",
                typeof(double), typeof(WaveEffect),
                new PropertyMetadata((double)(0),
                    PixelShaderConstantCallback(0)));

        public double Amplitude
        {
            get { return (double)GetValue(AmplitudeProperty); }
            set { SetValue(AmplitudeProperty, value); }
        }

        public WaveEffect()
        {
            var pixelShader = new PixelShader();
            pixelShader.UriSource = new Uri(
                "/ShaderTest;component/MyShaders/Wave.ps",
                UriKind.Relative);
            this.PixelShader = pixelShader;
            UpdateShaderValue(AmplitudeProperty);
        }
    }
}
