﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using TextBoxHandling.ViewModel;

namespace TextBoxHandling
{
    public partial class MainPage : UserControl, IAnimationService
    {
        public MainPage()
        {
            InitializeComponent();

            var vm = DataContext as MainViewModel;
            vm.AnimationService = this;
        }

        public void StartAnimation(string animationName)
        {
            if (Resources.Contains(animationName))
            {
                var sbd = Resources[animationName] as Storyboard;
                if (sbd != null)
                {
                    sbd.Begin();
                }
            }
        }

        public void StopAnimation(string animationName)
        {
            if (Resources.Contains(animationName))
            {
                var sbd = Resources[animationName] as Storyboard;
                if (sbd != null)
                {
                    sbd.Stop();
                }
            }
        }
    }
}
