﻿using System;
using System.ComponentModel;
using System.Threading;
using System.Windows;
using System.Windows.Threading;

namespace TextBoxHandling.Model
{
    public class NetworkService : INetworkService
    {
        // This class simulates a busy network by waiting 5 seconds before calling the callback

        private Action<bool> _callback;
        private Dispatcher _dispatcher;

        public NetworkService()
        {
            _dispatcher = Deployment.Current.Dispatcher;
        }

        public void Save(Action<bool> callback)
        {
            _callback = callback;
            var worker = new BackgroundWorker();
            worker.DoWork += worker_DoWork;
            worker.RunWorkerAsync();
        }

        void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            Thread.Sleep(5000);
            if (_callback != null)
            {
                _dispatcher.BeginInvoke(() => _callback(true));
            }
        }
    }
}