﻿using System;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using TextBoxHandling.Model;

namespace TextBoxHandling.ViewModel
{
    public class MainViewModel : ViewModelBase
    {
        public const string WaitAnimationName = "WaitAnimation";

        public const string CurrentCustomerPropertyName = "CurrentCustomer";
        private CustomerViewModel _customer = null;

        public CustomerViewModel CurrentCustomer
        {
            get
            {
                return _customer;
            }

            set
            {
                if (_customer == value)
                {
                    return;
                }

                _customer = value;
                RaisePropertyChanged(CurrentCustomerPropertyName);
            }
        }

        public IAnimationService AnimationService
        {
            get;
            set;
        }

        private readonly INetworkService _networkService;

        public MainViewModel(INetworkService networkService)
        {
            _networkService = networkService;
            CurrentCustomer = new CustomerViewModel();
        }
    }
}