﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Shapes; 
using System.Threading;

namespace ThreadPoolSample
{
    public partial class MainPage : UserControl
    {
        private const int NumberOfPrimes = 10000;

        public MainPage()
        {
            InitializeComponent();

            for (var index = 0; index < NumberOfPrimes; index++)
            {
                CalculatePrime(index);
            }
        }

        private void DisplayPrimeNumber(int prime)
        {
            var text = new TextBlock
            {
                Foreground = new SolidColorBrush(Colors.Red),
                FontSize = 24,
                Text = prime.ToString()
            };

            PrimeNumbersPanel.Children.Add(text);
        }

        private void CalculatePrime(int index)
        {
            ThreadPool.QueueUserWorkItem(
                o =>
                {
                    Thread.Sleep(10);

                    var root = (int)Math.Ceiling(Math.Sqrt(index));
                    var isPrime = false;

                    while (root > 1)
                    {
                        if (root != index
                            && index % root == 0)
                        {
                            isPrime = false;
                            break;
                        }
                        else if (!isPrime)
                        {
                            isPrime = true;
                        }

                        root--;
                    }

                    if (isPrime)
                    {
                        Dispatcher.BeginInvoke(() => DisplayPrimeNumber(index));
                    }
                });
        }
    }
}
