﻿using System;
using System.ComponentModel;

namespace ValidationSample.ViewModel
{
    public class ValidationViewModelWithExceptions : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public const string NamePropertyName = "Name";
        private string _name = string.Empty;

        public string Name
        {
            get
            {
                return _name;
            }

            set
            {
                if (_name == value)
                {
                    return;
                }

                if (string.IsNullOrEmpty(value))
                {
                    throw new Exception("Name should not be empty");
                }

                _name = value;

                if (PropertyChanged != null)
                {
                    PropertyChanged(
                        this, 
                        new PropertyChangedEventArgs(NamePropertyName));
                }
            }
        }
    }
}
