﻿using System;
using System.ComponentModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace ValidationSample.ViewModel
{
    public class ValidationViewModelWithIDataErrorInfo : INotifyPropertyChanged, IDataErrorInfo
    {
        public event PropertyChangedEventHandler PropertyChanged;

        //
        public string this[string columnName]
        {
            get
            {
                if (columnName == NamePropertyName)
                {
                    if (string.IsNullOrEmpty(_name))
                    {
                        return "Name should not be empty";
                    }
                }

                return null;
            }
        }

        public string Error
        {
            get
            {
                return null;
            }
        }

        public const string NamePropertyName = "Name";
        private string _name = string.Empty;

        public string Name
        {
            get
            {
                return _name;
            }

            set
            {
                if (_name == value)
                {
                    return;
                }

                _name = value;

                if (PropertyChanged != null)
                {
                    PropertyChanged(
                        this,
                        new PropertyChangedEventArgs(NamePropertyName));
                }
            }
        }
    }
}
