﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO.IsolatedStorage;
using System.IO;
using WebBrowserSample.Helpers;

namespace WebBrowserSample
{
    public partial class SaveFileChildWindow : ChildWindow
    {
        private LocalFileHelper _helper;

        public SaveFileChildWindow(string fileContent)
        {
            _helper = new LocalFileHelper
            {
                FileContent = fileContent
            };
            InitializeComponent();
        }

        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            var fileName = FileNameTextBox.Text.ToLower();

            if (_helper.FileExists(fileName))
            {
                MessageBox.Show("Already exists: " + FileNameTextBox.Text);
                return;
            }

            if (_helper.SaveFile(fileName))
            {
                DialogResult = true;
            }
            else
            {
                MessageBox.Show("Problem when saving, try again or cancel");
            }
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
        }
    }
}

