﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using WhyDependencyInjection.ViewModel;

namespace WhyDependencyInjection.Model
{
    public class DataService : IDataService
    {
        public string ServiceAddressUri
        {
            get
            {
                return "http://www.galasoft.ch/sl4u/Code/Chapter20/sample.txt";
            }
        }

        public void GetItems(Action<IEnumerable<Item>> callback)
        {
            var client = new WebClient();
            client.DownloadStringCompleted += ClientDownloadStringCompleted;
            client.DownloadStringAsync(new Uri(ServiceAddressUri), callback);
        }

        private void ClientDownloadStringCompleted(
            object sender, 
            DownloadStringCompletedEventArgs e)
        {
            var callback = e.UserState as Action<IEnumerable<Item>>;
            callback(ParseResult(e.Result));
        }

        private IEnumerable<Item> ParseResult(string serial)
        {
            var result = new List<Item>();

            // Parse the result and return items
            // The text file is simply a series of words, one word on each line.
            var items = serial.Split(
                new string[]
                {
                    Environment.NewLine
                }, 
                StringSplitOptions.RemoveEmptyEntries);

            foreach (var item in items)
            {
                result.Add(
                    new Item
                    {
                        Message = item
                    });
            }

            return result.AsEnumerable<Item>();
        }
    }
}
