﻿using System;
using System.ComponentModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Practices.Unity;
using WhyDependencyInjection.Design;
using WhyDependencyInjection.Model;
using WhyDependencyInjection.ViewModel;

namespace WhyDependencyInjection.Services
{
    public static class ServiceLocator
    {
        public static IUnityContainer Container
        {
            get; private set;
        }

        public static void Setup()
        {
            if (Container != null)
            {
                // Setup already done
                return;
            }

            Container = new UnityContainer();

            // Setup the service
            if (DesignerProperties.IsInDesignTool)
            {
                Container.RegisterType<IDataService, DesignDataService>();
            }
            else
            {
                Container.RegisterType<IDataService, DataService>();
            }

            // Setup the viewmodel
            Container.RegisterType<ViewModelWithDependencyInjection>(
                new ContainerControlledLifetimeManager());
        }
    }
}
