﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Linq;

namespace WhyDependencyInjection.ViewModel
{
// test
public class ViewModelWithoutDependencyInjection
{
    public string ServiceAddressUri { get; set; }

    public ObservableCollection<Item> Items
    {
        get;
        private set;
    }

    public ViewModelWithoutDependencyInjection()
    {
        Items = new ObservableCollection<Item>();

        if (DesignerProperties.IsInDesignTool)
        {
            for (var index = 0; index < 100; index++)
            {
                Items.Add(new Item());
            }
        }
        else
        {
            var client = new WebClient();
            client.DownloadStringCompleted += ClientDownloadStringCompleted;
            client.DownloadStringAsync(new Uri(ServiceAddressUri));
        }
    }

    private void ClientDownloadStringCompleted(
        object sender,
        DownloadStringCompletedEventArgs e)
    {
        Items = new ObservableCollection<Item>(ParseResult(e.Result));
    }

    private IEnumerable<Item> ParseResult(string serial)
    {
        var result = new List<Item>();

        // Parse the result and return items
        // The text file is simply a series of words, one word on each line.
        var items = serial.Split(
            new string[]
                {
                    Environment.NewLine
                },
            StringSplitOptions.RemoveEmptyEntries);

        foreach (var item in items)
        {
            result.Add(
                new Item
                {
                    Message = item
                });
        }

        return result.AsEnumerable<Item>();
    }
}
}
